package miscc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;

public class GeneratorTest {
    public static void main(String[] args) {
        try {
            InputStream in;
            PrintWriter out;

            if (args.length < 1)
                in = System.in;
            else
                in = new FileInputStream(args[0]);

            if (args.length < 2)
                out = new PrintWriter(System.out);
            else
                out = new PrintWriter(new FileOutputStream(args[1]));

            Parser parser = new Parser(in);
            Tree tree = parser.parse();
            in.close();
            Analyzer analyzer = new Analyzer();
            analyzer.analyze(tree);
            if (Report.errors == 0) {
                Generator generator = new Generator();
                CFG[] cfgs = generator.generate((Tree.Program)tree);
                CFGDotPrinter cfgPrinter = new CFGDotPrinter();
                Lineariser lineariser = new Lineariser();
                /* for (int i = 0; i < cfgs.length; ++i) {
                    CFG cfg = cfgs[i];
                    cfgPrinter.print(cfg, out);
                    Code c = new Code();
                    lineariser.lineariseCFG(cfg, c);
                    c.write(out);
                }
		*/
		Code c = 
		    lineariser.lineariseProgram(analyzer.scope,cfgs);
		c.write(out);

            }
            out.close();
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
