/*  miscc -- a compiler for misc
 *    Test application for the scanner
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: ParserTest.java,v 1.1 2004/04/02 14:44:27 schinz Exp $
 */

package miscc;

import java.io.*;

/** A small parser test class; it reads in a file and prints out
 *  every/the first syntax error that is found. Programs which
 *  do not yield error messages are supposed to be syntactically
 *  correct.
 *
 *  usage: java miscc.ParserTest <file.misc>
 */
public class ParserTest {
    public static void main(String[] args) {
        try {
            Parser p = new Parser(new FileInputStream(args[0]));
            p.parse();
            p.close();
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
