/*  miscc -- a compiler for misc
 *    Error management
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Report.java,v 1.1 2004/04/02 14:44:26 schinz Exp $
 */
package miscc;


/** This class provides functionality for printing error messages.
 */
class Report {

    /** Number of errors.
     */
    static int errors;

    /** Prints out an error message.
     */
    static void error(String message) {
        errors++;
        System.err.println(message);
    }

    /** Prints out an error message.
     */
    static void error(int position, String message) {
        errors++;
        print(position, message);
    }

    /** Prints out an error message and stops the program execution.
     */
    static void fail(String message) {
        error(message);
        System.exit(-1);
    }

    /** Prints out an error message and stops the program execution.
     */
    static void fail(int position, String message) {
        error(position, message);
        System.exit(-1);
    }

    /** Imprime la position et le message passs en argument. */
    private static void print(int position, String message) {
        System.err.println(Position.line(position) + ":" +
                           Position.column(position) + ": " +
                           message);
    }
}
