/*  miscc -- a compiler for misc
 *    Lexical token classes
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Tokens.java,v 1.1 2004/04/02 14:44:25 schinz Exp $
 */
package miscc;


/** This class defines all token classes of misc.
 */
interface Tokens {

    int EOF           = -1; // end of file
    int BAD           =  0; // unknown token

    int IDENT         =  1; // identifier
    int NUMBER        =  2; // number
    int STRING        =  3; // string

    int LPAREN        =  4; // "("
    int RPAREN        =  5; // ")"
    int LBRACE        =  6; // "{"
    int RBRACE        =  7; // "}"
    int LBRACKET      =  8; // "["
    int RBRACKET      =  9; // "]"
    int COMMA         = 10; // ","
    int SEMICOLON     = 11; // ";"
    int COLON         = 12; // ":"
    int CONS          = 13; // "::"
    int EQUAL         = 14; // "="
    int EQ            = 15; // "=="
    int NOT           = 16; // "!"
    int NE            = 17; // "!="
    int LT            = 18; // "<"
    int LE            = 19; // "<="
    int GT            = 20; // ">"
    int GE            = 21; // ">="
    int ARROW         = 22; // "=>"
    int ADD           = 23; // "+"
    int SUB           = 24; // "-"
    int MUL           = 25; // "*"
    int DIV           = 26; // "/"
    int MOD           = 27; // "%"
    int AND           = 28; // "&"
    int OR            = 29; // "|"

    int DEF           = 30; // "def"
    int VAR           = 31; // "var"
    int WHILE         = 32; // "while"
    int IF            = 33; // "if"
    int ELSE          = 34; // "else"
    int ANY           = 35; // "Any"
    int UNIT          = 36; // "Unit"
    int INT           = 37; // "Int"
    int LIST          = 38; // "List"
    int FALSE         = 39; // "false"
    int TRUE          = 40; // "true"
    int HEAD          = 41; // "head"
    int TAIL          = 42; // "tail"
    int IS_EMPTY      = 43; // "isEmpty"
}
