/*  miscc -- a compiler for misc
 *    Representation of the abstract syntax
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Visitor.java,v 1.1 2004/04/02 14:44:24 schinz Exp $
 */

package miscc;

import miscc.Tree.*;


/** The visitor interface.
 */
interface Visitor {
    void caseBad(Bad tree);
    void caseProgram(Program tree);
    void caseBody(Body tree);
    void caseFunDef(FunDef tree);
    void caseFormal(Formal tree);
    void caseBasicType(BasicType tree);
    void caseListType(ListType tree);
    void caseFunType(FunType tree);
    void caseVarDef(VarDef tree);
    void caseWhile(While tree);
    void caseExec(Exec tree);
    void caseIf(If tree);
    void caseAssign(Assign tree);
    void caseOperation(Operation tree);
    void caseListop(Listop tree);
    void caseIdent(Ident tree);
    void caseUnitLit(UnitLit tree);
    void caseNilLit(NilLit tree);
    void caseIntLit(IntLit tree);
    void caseApply(Apply tree);
}
